(function(root, factory) {
  if (typeof define === 'function' && define.amd) 
    define(['exports', 'kotlin', 'ktor-ktor-http-js-legacy', 'ktor-ktor-utils-js-legacy', 'ktor-ktor-client-core-js-legacy', 'ktor-ktor-io-js-legacy', 'kotlinx-coroutines-core'], factory);
  else if (typeof exports === 'object') 
    factory(module.exports, require('kotlin'), require('ktor-ktor-http-js-legacy'), require('ktor-ktor-utils-js-legacy'), require('ktor-ktor-client-core-js-legacy'), require('ktor-ktor-io-js-legacy'), require('kotlinx-coroutines-core'));
  else {
    if (typeof kotlin === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-client-logging-js-legacy'. Its dependency 'kotlin' was not found. Please, check whether 'kotlin' is loaded prior to 'ktor-ktor-client-logging-js-legacy'.");
    }
    if (typeof this['ktor-ktor-http-js-legacy'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-client-logging-js-legacy'. Its dependency 'ktor-ktor-http-js-legacy' was not found. Please, check whether 'ktor-ktor-http-js-legacy' is loaded prior to 'ktor-ktor-client-logging-js-legacy'.");
    }
    if (typeof this['ktor-ktor-utils-js-legacy'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-client-logging-js-legacy'. Its dependency 'ktor-ktor-utils-js-legacy' was not found. Please, check whether 'ktor-ktor-utils-js-legacy' is loaded prior to 'ktor-ktor-client-logging-js-legacy'.");
    }
    if (typeof this['ktor-ktor-client-core-js-legacy'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-client-logging-js-legacy'. Its dependency 'ktor-ktor-client-core-js-legacy' was not found. Please, check whether 'ktor-ktor-client-core-js-legacy' is loaded prior to 'ktor-ktor-client-logging-js-legacy'.");
    }
    if (typeof this['ktor-ktor-io-js-legacy'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-client-logging-js-legacy'. Its dependency 'ktor-ktor-io-js-legacy' was not found. Please, check whether 'ktor-ktor-io-js-legacy' is loaded prior to 'ktor-ktor-client-logging-js-legacy'.");
    }
    if (typeof this['kotlinx-coroutines-core'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-client-logging-js-legacy'. Its dependency 'kotlinx-coroutines-core' was not found. Please, check whether 'kotlinx-coroutines-core' is loaded prior to 'ktor-ktor-client-logging-js-legacy'.");
    }
    root['ktor-ktor-client-logging-js-legacy'] = factory(typeof this['ktor-ktor-client-logging-js-legacy'] === 'undefined' ? {} : this['ktor-ktor-client-logging-js-legacy'], kotlin, this['ktor-ktor-http-js-legacy'], this['ktor-ktor-utils-js-legacy'], this['ktor-ktor-client-core-js-legacy'], this['ktor-ktor-io-js-legacy'], this['kotlinx-coroutines-core']);
  }
}(this, function(_, Kotlin, $module$ktor_ktor_http_js_legacy, $module$ktor_ktor_utils_js_legacy, $module$ktor_ktor_client_core_js_legacy, $module$ktor_ktor_io_js_legacy, $module$kotlinx_coroutines_core) {
  'use strict';
  var $$importsForInline$$ = _.$$importsForInline$$ || (_.$$importsForInline$$ = {});
  var Enum = Kotlin.kotlin.Enum;
  var Kind_CLASS = Kotlin.Kind.CLASS;
  var throwISE = Kotlin.throwISE;
  var OutgoingContent$ReadChannelContent = $module$ktor_ktor_http_js_legacy.io.ktor.http.content.OutgoingContent.ReadChannelContent;
  var Kind_OBJECT = Kotlin.Kind.OBJECT;
  var Kind_INTERFACE = Kotlin.Kind.INTERFACE;
  var println = Kotlin.kotlin.io.println_s8jyv4$;
  var AttributeKey = $module$ktor_ktor_utils_js_legacy.io.ktor.util.AttributeKey;
  var HttpSendPipeline = $module$ktor_ktor_client_core_js_legacy.io.ktor.client.request.HttpSendPipeline;
  var Unit = Kotlin.kotlin.Unit;
  var Throwable = Error;
  var COROUTINE_SUSPENDED = Kotlin.kotlin.coroutines.intrinsics.COROUTINE_SUSPENDED;
  var CoroutineImpl = Kotlin.kotlin.coroutines.CoroutineImpl;
  var OutgoingContent = $module$ktor_ktor_http_js_legacy.io.ktor.http.content.OutgoingContent;
  var throwCCE = Kotlin.throwCCE;
  var Url = $module$ktor_ktor_http_js_legacy.io.ktor.http.Url_pboq08$;
  var http = $module$ktor_ktor_http_js_legacy.io.ktor.http;
  var StringBuilder_init = Kotlin.kotlin.text.StringBuilder_init;
  var toString = Kotlin.toString;
  var charset = $module$ktor_ktor_http_js_legacy.io.ktor.http.charset_10ldo9$;
  var charsets = $module$ktor_ktor_io_js_legacy.io.ktor.utils.io.charsets;
  var ByteChannel = $module$ktor_ktor_io_js_legacy.io.ktor.utils.io.ByteChannel_6taknv$;
  var coroutines = $module$kotlinx_coroutines_core.kotlinx.coroutines;
  var launch = $module$kotlinx_coroutines_core.kotlinx.coroutines.launch_s496o7$;
  var HttpReceivePipeline = $module$ktor_ktor_client_core_js_legacy.io.ktor.client.statement.HttpReceivePipeline;
  var HttpResponsePipeline = $module$ktor_ktor_client_core_js_legacy.io.ktor.client.statement.HttpResponsePipeline;
  var contentType = $module$ktor_ktor_http_js_legacy.io.ktor.http.contentType_v1wgmc$;
  var ResponseObserver = $module$ktor_ktor_client_core_js_legacy.io.ktor.client.plugins.observer.ResponseObserver;
  var HttpClientPlugin = $module$ktor_ktor_client_core_js_legacy.io.ktor.client.plugins.HttpClientPlugin;
  var emptyList = Kotlin.kotlin.collections.emptyList_287e2$;
  var readText = $module$ktor_ktor_io_js_legacy.io.ktor.utils.io.core.readText_1lnizf$;
  var defineInlineFunction = Kotlin.defineInlineFunction;
  var wrapFunction = Kotlin.wrapFunction;
  var ArrayList_init = Kotlin.kotlin.collections.ArrayList_init_287e2$;
  var Collection = Kotlin.kotlin.collections.Collection;
  var trim = Kotlin.kotlin.text.trim_gw00vp$;
  var toList = Kotlin.kotlin.collections.toList_7wnvza$;
  var joinToString = Kotlin.kotlin.collections.joinToString_fmv235$;
  var sortedWith = Kotlin.kotlin.collections.sortedWith_eknfly$;
  var Comparator = Kotlin.kotlin.Comparator;
  var writeFully = $module$ktor_ktor_io_js_legacy.io.ktor.utils.io.writeFully_4scpqu$;
  var close = $module$ktor_ktor_io_js_legacy.io.ktor.utils.io.close_x5qia6$;
  var OutgoingContent$ByteArrayContent = $module$ktor_ktor_http_js_legacy.io.ktor.http.content.OutgoingContent.ByteArrayContent;
  var copyToBoth = $module$ktor_ktor_utils_js_legacy.io.ktor.util.copyToBoth_xeww6r$;
  var OutgoingContent$WriteChannelContent = $module$ktor_ktor_http_js_legacy.io.ktor.http.content.OutgoingContent.WriteChannelContent;
  var writer = $module$ktor_ktor_io_js_legacy.io.ktor.utils.io.writer_x9a1ni$;
  LogLevel.prototype = Object.create(Enum.prototype);
  LogLevel.prototype.constructor = LogLevel;
  LoggedContent.prototype = Object.create(OutgoingContent$ReadChannelContent.prototype);
  LoggedContent.prototype.constructor = LoggedContent;
  function LogLevel(name, ordinal, info, headers, body) {
    Enum.call(this);
    this.info = info;
    this.headers = headers;
    this.body = body;
    this.name$ = name;
    this.ordinal$ = ordinal;
  }
  function LogLevel_initFields() {
    LogLevel_initFields = function() {
};
    LogLevel$ALL_instance = new LogLevel('ALL', 0, true, true, true);
    LogLevel$HEADERS_instance = new LogLevel('HEADERS', 1, true, true, false);
    LogLevel$BODY_instance = new LogLevel('BODY', 2, true, false, true);
    LogLevel$INFO_instance = new LogLevel('INFO', 3, true, false, false);
    LogLevel$NONE_instance = new LogLevel('NONE', 4, false, false, false);
  }
  var LogLevel$ALL_instance;
  function LogLevel$ALL_getInstance() {
    LogLevel_initFields();
    return LogLevel$ALL_instance;
  }
  var LogLevel$HEADERS_instance;
  function LogLevel$HEADERS_getInstance() {
    LogLevel_initFields();
    return LogLevel$HEADERS_instance;
  }
  var LogLevel$BODY_instance;
  function LogLevel$BODY_getInstance() {
    LogLevel_initFields();
    return LogLevel$BODY_instance;
  }
  var LogLevel$INFO_instance;
  function LogLevel$INFO_getInstance() {
    LogLevel_initFields();
    return LogLevel$INFO_instance;
  }
  var LogLevel$NONE_instance;
  function LogLevel$NONE_getInstance() {
    LogLevel_initFields();
    return LogLevel$NONE_instance;
  }
  LogLevel.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'LogLevel', 
  interfaces: [Enum]};
  function LogLevel$values() {
    return [LogLevel$ALL_getInstance(), LogLevel$HEADERS_getInstance(), LogLevel$BODY_getInstance(), LogLevel$INFO_getInstance(), LogLevel$NONE_getInstance()];
  }
  LogLevel.values = LogLevel$values;
  function LogLevel$valueOf(name) {
    switch (name) {
      case 'ALL':
        return LogLevel$ALL_getInstance();
      case 'HEADERS':
        return LogLevel$HEADERS_getInstance();
      case 'BODY':
        return LogLevel$BODY_getInstance();
      case 'INFO':
        return LogLevel$INFO_getInstance();
      case 'NONE':
        return LogLevel$NONE_getInstance();
      default:
        throwISE('No enum constant io.ktor.client.plugins.logging.LogLevel.' + name);
    }
  }
  LogLevel.valueOf_61zpoe$ = LogLevel$valueOf;
  function LoggedContent(originalContent, channel) {
    OutgoingContent$ReadChannelContent.call(this);
    this.originalContent_0 = originalContent;
    this.channel_0 = channel;
    this.contentType_cjbb2c$_0 = this.originalContent_0.contentType;
    this.contentLength_cj6lwo$_0 = this.originalContent_0.contentLength;
    this.status_14irkl$_0 = this.originalContent_0.status;
    this.headers_445ojz$_0 = this.originalContent_0.headers;
  }
  Object.defineProperty(LoggedContent.prototype, 'contentType', {
  configurable: true, 
  get: function() {
  return this.contentType_cjbb2c$_0;
}});
  Object.defineProperty(LoggedContent.prototype, 'contentLength', {
  configurable: true, 
  get: function() {
  return this.contentLength_cj6lwo$_0;
}});
  Object.defineProperty(LoggedContent.prototype, 'status', {
  configurable: true, 
  get: function() {
  return this.status_14irkl$_0;
}});
  Object.defineProperty(LoggedContent.prototype, 'headers', {
  configurable: true, 
  get: function() {
  return this.headers_445ojz$_0;
}});
  LoggedContent.prototype.getProperty_yzaw86$ = function(key) {
  return this.originalContent_0.getProperty_yzaw86$(key);
};
  LoggedContent.prototype.setProperty_uuntuo$ = function(key, value) {
  this.originalContent_0.setProperty_uuntuo$(key, value);
};
  LoggedContent.prototype.readFrom = function() {
  return this.channel_0;
};
  LoggedContent.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'LoggedContent', 
  interfaces: [OutgoingContent$ReadChannelContent]};
  function Logger() {
    Logger$Companion_getInstance();
  }
  function Logger$Companion() {
    Logger$Companion_instance = this;
  }
  Logger$Companion.$metadata$ = {
  kind: Kind_OBJECT, 
  simpleName: 'Companion', 
  interfaces: []};
  var Logger$Companion_instance = null;
  function Logger$Companion_getInstance() {
    if (Logger$Companion_instance === null) {
      new Logger$Companion();
    }
    return Logger$Companion_instance;
  }
  Logger.$metadata$ = {
  kind: Kind_INTERFACE, 
  simpleName: 'Logger', 
  interfaces: []};
  function get_SIMPLE($receiver) {
    return new SimpleLogger();
  }
  function get_EMPTY$ObjectLiteral() {
  }
  get_EMPTY$ObjectLiteral.prototype.log_61zpoe$ = function(message) {
};
  get_EMPTY$ObjectLiteral.$metadata$ = {
  kind: Kind_CLASS, 
  interfaces: [Logger]};
  function get_EMPTY($receiver) {
    return new get_EMPTY$ObjectLiteral();
  }
  function SimpleLogger() {
  }
  SimpleLogger.prototype.log_61zpoe$ = function(message) {
  println('HttpClient: ' + message);
};
  SimpleLogger.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'SimpleLogger', 
  interfaces: [Logger]};
  var HttpResponseLog;
  var DisableLogging;
  function Logging(logger, level, filters) {
    Logging$Companion_getInstance();
    if (filters === void 0) 
      filters = emptyList();
    this.logger = logger;
    this.level = level;
    this.filters = filters;
  }
  function Logging$Config() {
    this.filters_8be2vx$ = ArrayList_init();
    this.logger = get_DEFAULT(Logger$Companion_getInstance());
    this.level = LogLevel$HEADERS_getInstance();
  }
  Logging$Config.prototype.filter_j4x09n$ = function(predicate) {
  this.filters_8be2vx$.add_11rb$(predicate);
};
  Logging$Config.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'Config', 
  interfaces: []};
  function Coroutine$Logging$setupRequestLogging$lambda(this$Logging_0, $receiver_0, it_0, controller, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.$controller = controller;
    this.exceptionState_0 = 10;
    this.local$this$Logging = this$Logging_0;
    this.local$tmp$ = void 0;
    this.local$$receiver = $receiver_0;
  }
  Coroutine$Logging$setupRequestLogging$lambda.$metadata$ = {
  kind: Kotlin.Kind.CLASS, 
  simpleName: null, 
  interfaces: [CoroutineImpl]};
  Coroutine$Logging$setupRequestLogging$lambda.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$Logging$setupRequestLogging$lambda.prototype.constructor = Coroutine$Logging$setupRequestLogging$lambda;
  Coroutine$Logging$setupRequestLogging$lambda.prototype.doResume = function() {
  do try {
    switch (this.state_0) {
      case 0:
        if (!this.local$this$Logging.shouldBeLogged_0(this.local$$receiver.context)) {
          this.local$$receiver.context.attributes.put_uuntuo$(DisableLogging, Unit);
          return;
        } else {
          this.state_0 = 1;
          continue;
        }
      case 1:
        this.exceptionState_0 = 3;
        this.state_0 = 2;
        this.result_0 = this.local$this$Logging.logRequest_0(this.local$$receiver.context, this);
        if (this.result_0 === COROUTINE_SUSPENDED) 
          return COROUTINE_SUSPENDED;
        continue;
      case 2:
        this.local$tmp$ = this.result_0;
        this.exceptionState_0 = 10;
        this.state_0 = 4;
        continue;
      case 3:
        this.exceptionState_0 = 10;
        var _ = this.exception_0;
        if (Kotlin.isType(_, Throwable)) {
          this.local$tmp$ = null;
        } else 
          throw _;
        this.state_0 = 4;
        continue;
      case 4:
        var response = this.local$tmp$;
        this.exceptionState_0 = 7;
        this.state_0 = 5;
        this.result_0 = this.local$$receiver.proceedWith_trkh7z$(response != null ? response : this.local$$receiver.subject, this);
        if (this.result_0 === COROUTINE_SUSPENDED) 
          return COROUTINE_SUSPENDED;
        continue;
      case 5:
        this.exceptionState_0 = 10;
        this.finallyPath_0 = [6];
        this.state_0 = 8;
        this.$returnValue = this.result_0;
        continue;
      case 6:
        return this.$returnValue;
      case 7:
        this.finallyPath_0 = [10];
        this.exceptionState_0 = 8;
        var cause = this.exception_0;
        if (Kotlin.isType(cause, Throwable)) {
          this.local$this$Logging.logRequestException_0(this.local$$receiver.context, cause);
          throw cause;
        } else 
          throw cause;
      case 8:
        this.exceptionState_0 = 10;
        this.state_0 = this.finallyPath_0.shift();
        continue;
      case 9:
        return;
      case 10:
        throw this.exception_0;
      default:
        this.state_0 = 10;
        throw new Error('State Machine Unreachable execution');
    }
  }  catch (e) {
  if (this.state_0 === 10) {
    this.exceptionState_0 = this.state_0;
    throw e;
  } else {
    this.state_0 = this.exceptionState_0;
    this.exception_0 = e;
  }
} while (true);
};
  function Logging$setupRequestLogging$lambda(this$Logging_0) {
    return function($receiver_0, it_0, continuation_0, suspended) {
  var instance = new Coroutine$Logging$setupRequestLogging$lambda(this$Logging_0, $receiver_0, it_0, this, continuation_0);
  if (suspended) 
    return instance;
  else 
    return instance.doResume(null);
};
  }
  Logging.prototype.setupRequestLogging_0 = function(client) {
  client.sendPipeline.intercept_h71y74$(HttpSendPipeline.Phases.Monitoring, Logging$setupRequestLogging$lambda(this));
};
  Logging.prototype.shouldBeLogged_0 = function(request) {
  var tmp$ = this.filters.isEmpty();
  if (!tmp$) {
    var $receiver = this.filters;
    var any$result;
    any$break:
      do {
        var tmp$_0;
        if (Kotlin.isType($receiver, Collection) && $receiver.isEmpty()) {
          any$result = false;
          break any$break;
        }
        tmp$_0 = $receiver.iterator();
        while (tmp$_0.hasNext()) {
          var element = tmp$_0.next();
          if (element(request)) {
            any$result = true;
            break any$break;
          }
        }
        any$result = false;
      } while (false);
    tmp$ = any$result;
  }
  return tmp$;
};
  function Coroutine$logRequest_0($this, request_0, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.exceptionState_0 = 1;
    this.$this = $this;
    this.local$tmp$_0 = void 0;
    this.local$request = request_0;
  }
  Coroutine$logRequest_0.$metadata$ = {
  kind: Kotlin.Kind.CLASS, 
  simpleName: null, 
  interfaces: [CoroutineImpl]};
  Coroutine$logRequest_0.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$logRequest_0.prototype.constructor = Coroutine$logRequest_0;
  Coroutine$logRequest_0.prototype.doResume = function() {
  do try {
    switch (this.state_0) {
      case 0:
        var tmp$;
        var content = Kotlin.isType(tmp$ = this.local$request.body, OutgoingContent) ? tmp$ : throwCCE();
        var $receiver = StringBuilder_init();
        var tmp$_0, tmp$_1;
        if (this.$this.level.info) {
          var value = 'REQUEST: ' + Url(this.local$request.url);
          $receiver.append_pdl1vj$(value).append_s8itvh$(10);
          var value_0 = 'METHOD: ' + this.local$request.method;
          $receiver.append_pdl1vj$(value_0).append_s8itvh$(10);
        }
        if (this.$this.level.headers) {
          var value_1 = 'COMMON HEADERS';
          $receiver.append_pdl1vj$(value_1).append_s8itvh$(10);
          logHeaders($receiver, this.local$request.headers.entries());
          var value_2 = 'CONTENT HEADERS';
          $receiver.append_pdl1vj$(value_2).append_s8itvh$(10);
          if ((tmp$_0 = content.contentLength) != null) {
            logHeader($receiver, http.HttpHeaders.ContentLength, tmp$_0.toString());
          }
          if ((tmp$_1 = content.contentType) != null) {
            logHeader($receiver, http.HttpHeaders.ContentType, tmp$_1.toString());
          }
          logHeaders($receiver, content.headers.entries());
        }
        var message = $receiver.toString();
        if (message.length > 0) {
          var tmp$_2;
          this.$this.logger.log_61zpoe$(trim(Kotlin.isCharSequence(tmp$_2 = message) ? tmp$_2 : throwCCE()).toString());
        }
        if (this.$this.level.body) {
          this.state_0 = 2;
          this.result_0 = this.$this.logRequestBody_0(content, this);
          if (this.result_0 === COROUTINE_SUSPENDED) 
            return COROUTINE_SUSPENDED;
          continue;
        } else {
          this.local$tmp$_0 = null;
          this.state_0 = 3;
          continue;
        }
      case 1:
        throw this.exception_0;
      case 2:
        this.local$tmp$_0 = this.result_0;
        this.state_0 = 3;
        continue;
      case 3:
        return this.local$tmp$_0;
      default:
        this.state_0 = 1;
        throw new Error('State Machine Unreachable execution');
    }
  }  catch (e) {
  if (this.state_0 === 1) {
    this.exceptionState_0 = this.state_0;
    throw e;
  } else {
    this.state_0 = this.exceptionState_0;
    this.exception_0 = e;
  }
} while (true);
};
  Logging.prototype.logRequest_0 = function(request_0, continuation_0, suspended) {
  var instance = new Coroutine$logRequest_0(this, request_0, continuation_0);
  if (suspended) 
    return instance;
  else 
    return instance.doResume(null);
};
  function Coroutine$Logging$logRequestBody$lambda(closure$channel_0, closure$charset_0, closure$bodyLog_0, this$Logging_0, $receiver_0, controller, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.$controller = controller;
    this.exceptionState_0 = 7;
    this.local$closure$channel = closure$channel_0;
    this.local$closure$charset = closure$charset_0;
    this.local$closure$bodyLog = closure$bodyLog_0;
    this.local$this$Logging = this$Logging_0;
    this.local$$receiver = void 0;
    this.local$charset = void 0;
  }
  Coroutine$Logging$logRequestBody$lambda.$metadata$ = {
  kind: Kotlin.Kind.CLASS, 
  simpleName: null, 
  interfaces: [CoroutineImpl]};
  Coroutine$Logging$logRequestBody$lambda.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$Logging$logRequestBody$lambda.prototype.constructor = Coroutine$Logging$logRequestBody$lambda;
  Coroutine$Logging$logRequestBody$lambda.prototype.doResume = function() {
  do try {
    switch (this.state_0) {
      case 0:
        var tmp$;
        this.local$$receiver = this.local$closure$channel;
        this.local$charset = this.local$closure$charset;
        this.state_0 = 1;
        continue;
      case 1:
        this.exceptionState_0 = 3;
        this.state_0 = 2;
        this.result_0 = this.local$$receiver.readRemaining_s8cxhz$(void 0, this);
        if (this.result_0 === COROUTINE_SUSPENDED) 
          return COROUTINE_SUSPENDED;
        continue;
      case 2:
        this.result_0 = readText(this.result_0, this.local$charset);
        this.exceptionState_0 = 7;
        this.state_0 = 5;
        continue;
      case 3:
        this.exceptionState_0 = 7;
        var cause = this.exception_0;
        if (Kotlin.isType(cause, Throwable)) {
          this.result_0 = null;
          this.exceptionState_0 = 3;
          this.state_0 = 6;
          continue;
        } else {
          throw cause;
        }
      case 4:
        this.state_0 = 5;
        continue;
      case 5:
        if (!false) {
          this.state_0 = 6;
          continue;
        }
        this.state_0 = 1;
        continue;
      case 6:
        var text = (tmp$ = this.result_0) != null ? tmp$ : '[request body omitted]';
        var $receiver = this.local$closure$bodyLog;
        var value = 'BODY START';
        $receiver.append_pdl1vj$(value).append_s8itvh$(10);
        this.local$closure$bodyLog.append_pdl1vj$(text).append_s8itvh$(10);
        this.local$closure$bodyLog.append_pdl1vj$('BODY END');
        return this.local$this$Logging.logger.log_61zpoe$(this.local$closure$bodyLog.toString()) , Unit;
      case 7:
        throw this.exception_0;
      default:
        this.state_0 = 7;
        throw new Error('State Machine Unreachable execution');
    }
  }  catch (e) {
  if (this.state_0 === 7) {
    this.exceptionState_0 = this.state_0;
    throw e;
  } else {
    this.state_0 = this.exceptionState_0;
    this.exception_0 = e;
  }
} while (true);
};
  function Logging$logRequestBody$lambda(closure$channel_0, closure$charset_0, closure$bodyLog_0, this$Logging_0) {
    return function($receiver_0, continuation_0, suspended) {
  var instance = new Coroutine$Logging$logRequestBody$lambda(closure$channel_0, closure$charset_0, closure$bodyLog_0, this$Logging_0, $receiver_0, this, continuation_0);
  if (suspended) 
    return instance;
  else 
    return instance.doResume(null);
};
  }
  Logging.prototype.logRequestBody_0 = function(content, continuation) {
  var tmp$, tmp$_0;
  var bodyLog = StringBuilder_init();
  var value = 'BODY Content-Type: ' + toString(content.contentType);
  bodyLog.append_pdl1vj$(value).append_s8itvh$(10);
  var charset_0 = (tmp$_0 = (tmp$ = content.contentType) != null ? charset(tmp$) : null) != null ? tmp$_0 : charsets.Charsets.UTF_8;
  var channel = ByteChannel();
  launch(coroutines.GlobalScope, coroutines.Dispatchers.Unconfined, void 0, Logging$logRequestBody$lambda(channel, charset_0, bodyLog, this));
  return observe(content, channel, continuation);
};
  Logging.prototype.logRequestException_0 = function(context, cause) {
  if (this.level.info) {
    this.logger.log_61zpoe$('REQUEST ' + Url(context.url) + ' failed with exception: ' + cause);
  }
};
  function Coroutine$Logging$setupResponseLogging$lambda(this$Logging_0, $receiver_0, response_0, controller, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.$controller = controller;
    this.exceptionState_0 = 6;
    this.local$this$Logging = this$Logging_0;
    this.local$log = void 0;
    this.local$$receiver = $receiver_0;
    this.local$response = response_0;
  }
  Coroutine$Logging$setupResponseLogging$lambda.$metadata$ = {
  kind: Kotlin.Kind.CLASS, 
  simpleName: null, 
  interfaces: [CoroutineImpl]};
  Coroutine$Logging$setupResponseLogging$lambda.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$Logging$setupResponseLogging$lambda.prototype.constructor = Coroutine$Logging$setupResponseLogging$lambda;
  Coroutine$Logging$setupResponseLogging$lambda.prototype.doResume = function() {
  do try {
    switch (this.state_0) {
      case 0:
        if (this.local$this$Logging.level === LogLevel$NONE_getInstance() || this.local$response.call.attributes.contains_w48dwb$(DisableLogging)) {
          return;
        } else {
          this.state_0 = 1;
          continue;
        }
      case 1:
        this.local$log = StringBuilder_init();
        if (this.local$this$Logging.level.body) {
          this.local$response.call.attributes.put_uuntuo$(HttpResponseLog, this.local$log);
        }
        this.exceptionState_0 = 4;
        this.local$this$Logging.logResponseHeader_0(this.local$log, this.local$response.call.response);
        this.state_0 = 2;
        this.result_0 = this.local$$receiver.proceedWith_trkh7z$(this.local$$receiver.subject, this);
        if (this.result_0 === COROUTINE_SUSPENDED) 
          return COROUTINE_SUSPENDED;
        continue;
      case 2:
        if (!this.local$this$Logging.level.body) {
          var tmp$ = this.local$this$Logging.logger;
          var $receiver = this.local$log.toString();
          var tmp$_0;
          return tmp$.log_61zpoe$(trim(Kotlin.isCharSequence(tmp$_0 = $receiver) ? tmp$_0 : throwCCE()).toString()) , Unit;
        } else {
          this.state_0 = 3;
          continue;
        }
      case 3:
        this.exceptionState_0 = 6;
        this.state_0 = 5;
        continue;
      case 4:
        this.exceptionState_0 = 6;
        var cause = this.exception_0;
        if (Kotlin.isType(cause, Throwable)) {
          var tmp$_1 = this.local$this$Logging.logger;
          var $receiver_0 = this.local$log.toString();
          var tmp$_2;
          tmp$_1.log_61zpoe$(trim(Kotlin.isCharSequence(tmp$_2 = $receiver_0) ? tmp$_2 : throwCCE()).toString());
          this.local$this$Logging.logResponseException_0(this.local$response.call.request, cause);
          throw cause;
        } else 
          throw cause;
      case 5:
        return Unit;
      case 6:
        throw this.exception_0;
      default:
        this.state_0 = 6;
        throw new Error('State Machine Unreachable execution');
    }
  }  catch (e) {
  if (this.state_0 === 6) {
    this.exceptionState_0 = this.state_0;
    throw e;
  } else {
    this.state_0 = this.exceptionState_0;
    this.exception_0 = e;
  }
} while (true);
};
  function Logging$setupResponseLogging$lambda(this$Logging_0) {
    return function($receiver_0, response_0, continuation_0, suspended) {
  var instance = new Coroutine$Logging$setupResponseLogging$lambda(this$Logging_0, $receiver_0, response_0, this, continuation_0);
  if (suspended) 
    return instance;
  else 
    return instance.doResume(null);
};
  }
  function Coroutine$Logging$setupResponseLogging$lambda_0(this$Logging_0, $receiver_0, it_0, controller, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.$controller = controller;
    this.exceptionState_0 = 5;
    this.local$this$Logging = this$Logging_0;
    this.local$$receiver = $receiver_0;
  }
  Coroutine$Logging$setupResponseLogging$lambda_0.$metadata$ = {
  kind: Kotlin.Kind.CLASS, 
  simpleName: null, 
  interfaces: [CoroutineImpl]};
  Coroutine$Logging$setupResponseLogging$lambda_0.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$Logging$setupResponseLogging$lambda_0.prototype.constructor = Coroutine$Logging$setupResponseLogging$lambda_0;
  Coroutine$Logging$setupResponseLogging$lambda_0.prototype.doResume = function() {
  do try {
    switch (this.state_0) {
      case 0:
        if (this.local$this$Logging.level === LogLevel$NONE_getInstance() || this.local$$receiver.context.attributes.contains_w48dwb$(DisableLogging)) {
          return;
        } else {
          this.state_0 = 1;
          continue;
        }
      case 1:
        this.exceptionState_0 = 3;
        this.state_0 = 2;
        this.result_0 = this.local$$receiver.proceed(this);
        if (this.result_0 === COROUTINE_SUSPENDED) 
          return COROUTINE_SUSPENDED;
        continue;
      case 2:
        return this.result_0;
      case 3:
        this.exceptionState_0 = 5;
        var cause = this.exception_0;
        if (Kotlin.isType(cause, Throwable)) {
          this.local$this$Logging.logResponseException_0(this.local$$receiver.context.request, cause);
          throw cause;
        } else 
          throw cause;
      case 4:
        return;
      case 5:
        throw this.exception_0;
      default:
        this.state_0 = 5;
        throw new Error('State Machine Unreachable execution');
    }
  }  catch (e) {
  if (this.state_0 === 5) {
    this.exceptionState_0 = this.state_0;
    throw e;
  } else {
    this.state_0 = this.exceptionState_0;
    this.exception_0 = e;
  }
} while (true);
};
  function Logging$setupResponseLogging$lambda_0(this$Logging_0) {
    return function($receiver_0, it_0, continuation_0, suspended) {
  var instance = new Coroutine$Logging$setupResponseLogging$lambda_0(this$Logging_0, $receiver_0, it_0, this, continuation_0);
  if (suspended) 
    return instance;
  else 
    return instance.doResume(null);
};
  }
  function Coroutine$Logging$setupResponseLogging$lambda_1(this$Logging_0, it_0, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.exceptionState_0 = 9;
    this.local$this$Logging = this$Logging_0;
    this.local$log = void 0;
    this.local$it = it_0;
  }
  Coroutine$Logging$setupResponseLogging$lambda_1.$metadata$ = {
  kind: Kotlin.Kind.CLASS, 
  simpleName: null, 
  interfaces: [CoroutineImpl]};
  Coroutine$Logging$setupResponseLogging$lambda_1.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$Logging$setupResponseLogging$lambda_1.prototype.constructor = Coroutine$Logging$setupResponseLogging$lambda_1;
  Coroutine$Logging$setupResponseLogging$lambda_1.prototype.doResume = function() {
  do try {
    switch (this.state_0) {
      case 0:
        if (this.local$this$Logging.level === LogLevel$NONE_getInstance() || this.local$it.call.attributes.contains_w48dwb$(DisableLogging)) {
          return;
        } else {
          this.state_0 = 1;
          continue;
        }
      case 1:
        this.local$log = this.local$it.call.attributes.get_yzaw86$(HttpResponseLog);
        this.exceptionState_0 = 4;
        this.state_0 = 2;
        this.result_0 = this.local$this$Logging.logResponseBody_0(this.local$log, contentType(this.local$it), this.local$it.content, this);
        if (this.result_0 === COROUTINE_SUSPENDED) 
          return COROUTINE_SUSPENDED;
        continue;
      case 2:
        this.exceptionState_0 = 9;
        this.finallyPath_0 = [3];
        this.state_0 = 7;
        this.$returnValue = this.result_0;
        continue;
      case 3:
        return this.$returnValue;
      case 4:
        this.finallyPath_0 = [9];
        this.exceptionState_0 = 7;
        var _ = this.exception_0;
        if (Kotlin.isType(_, Throwable)) {
          this.exceptionState_0 = 9;
          this.finallyPath_0 = [5];
          this.state_0 = 7;
          this.$returnValue = Unit;
          continue;
        } else {
          throw _;
        }
      case 5:
        return this.$returnValue;
      case 6:
        this.finallyPath_0 = [8];
        this.state_0 = 7;
        continue;
      case 7:
        this.exceptionState_0 = 9;
        var tmp$ = this.local$this$Logging.logger;
        var $receiver = this.local$log.toString();
        var tmp$_0;
        tmp$.log_61zpoe$(trim(Kotlin.isCharSequence(tmp$_0 = $receiver) ? tmp$_0 : throwCCE()).toString());
        this.state_0 = this.finallyPath_0.shift();
        continue;
      case 8:
        return;
      case 9:
        throw this.exception_0;
      default:
        this.state_0 = 9;
        throw new Error('State Machine Unreachable execution');
    }
  }  catch (e) {
  if (this.state_0 === 9) {
    this.exceptionState_0 = this.state_0;
    throw e;
  } else {
    this.state_0 = this.exceptionState_0;
    this.exception_0 = e;
  }
} while (true);
};
  function Logging$setupResponseLogging$lambda_1(this$Logging_0) {
    return function(it_0, continuation_0, suspended) {
  var instance = new Coroutine$Logging$setupResponseLogging$lambda_1(this$Logging_0, it_0, continuation_0);
  if (suspended) 
    return instance;
  else 
    return instance.doResume(null);
};
  }
  Logging.prototype.setupResponseLogging_0 = function(client) {
  client.receivePipeline.intercept_h71y74$(HttpReceivePipeline.Phases.State, Logging$setupResponseLogging$lambda(this));
  client.responsePipeline.intercept_h71y74$(HttpResponsePipeline.Phases.Receive, Logging$setupResponseLogging$lambda_0(this));
  if (!this.level.body) 
    return;
  var observer = Logging$setupResponseLogging$lambda_1(this);
  ResponseObserver.Plugin.install_wojrb5$(new ResponseObserver(observer), client);
};
  Logging.prototype.logResponseHeader_0 = function(log, response) {
  if (this.level.info) {
    var value = 'RESPONSE: ' + response.status;
    log.append_pdl1vj$(value).append_s8itvh$(10);
    var value_0 = 'METHOD: ' + response.call.request.method;
    log.append_pdl1vj$(value_0).append_s8itvh$(10);
    var value_1 = 'FROM: ' + response.call.request.url;
    log.append_pdl1vj$(value_1).append_s8itvh$(10);
  }
  if (this.level.headers) {
    var value_2 = 'COMMON HEADERS';
    log.append_pdl1vj$(value_2).append_s8itvh$(10);
    logHeaders(log, response.headers.entries());
  }
};
  function Coroutine$logResponseBody_0($this, log_0, contentType_0, content_0, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.exceptionState_0 = 7;
    this.$this = $this;
    this.local$tmp$_0 = void 0;
    this.local$log = log_0;
    this.local$contentType = contentType_0;
    this.local$content = content_0;
  }
  Coroutine$logResponseBody_0.$metadata$ = {
  kind: Kotlin.Kind.CLASS, 
  simpleName: null, 
  interfaces: [CoroutineImpl]};
  Coroutine$logResponseBody_0.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$logResponseBody_0.prototype.constructor = Coroutine$logResponseBody_0;
  Coroutine$logResponseBody_0.prototype.doResume = function() {
  do try {
    switch (this.state_0) {
      case 0:
        var tmp$;
        var tmp$_0;
        var value = 'BODY Content-Type: ' + toString(this.local$contentType);
        this.local$log.append_pdl1vj$(value).append_s8itvh$(10);
        var value_0 = 'BODY START';
        this.local$log.append_pdl1vj$(value_0).append_s8itvh$(10);
        this.local$tmp$_0 = (tmp$ = this.local$contentType != null ? charset(this.local$contentType) : null) != null ? tmp$ : charsets.Charsets.UTF_8;
        this.state_0 = 1;
        continue;
      case 1:
        this.exceptionState_0 = 3;
        this.state_0 = 2;
        this.result_0 = this.local$content.readRemaining_s8cxhz$(void 0, this);
        if (this.result_0 === COROUTINE_SUSPENDED) 
          return COROUTINE_SUSPENDED;
        continue;
      case 2:
        this.result_0 = readText(this.result_0, this.local$tmp$_0);
        this.exceptionState_0 = 7;
        this.state_0 = 5;
        continue;
      case 3:
        this.exceptionState_0 = 7;
        var cause = this.exception_0;
        if (Kotlin.isType(cause, Throwable)) {
          this.result_0 = null;
          this.exceptionState_0 = 3;
          this.state_0 = 6;
          continue;
        } else {
          throw cause;
        }
      case 4:
        this.state_0 = 5;
        continue;
      case 5:
        if (!false) {
          this.state_0 = 6;
          continue;
        }
        this.state_0 = 1;
        continue;
      case 6:
        var message = (tmp$_0 = this.result_0) != null ? tmp$_0 : '[response body omitted]';
        this.local$log.append_pdl1vj$(message).append_s8itvh$(10);
        this.local$log.append_pdl1vj$('BODY END');
        return;
      case 7:
        throw this.exception_0;
      default:
        this.state_0 = 7;
        throw new Error('State Machine Unreachable execution');
    }
  }  catch (e) {
  if (this.state_0 === 7) {
    this.exceptionState_0 = this.state_0;
    throw e;
  } else {
    this.state_0 = this.exceptionState_0;
    this.exception_0 = e;
  }
} while (true);
};
  Logging.prototype.logResponseBody_0 = function(log_0, contentType_0, content_0, continuation_0, suspended) {
  var instance = new Coroutine$logResponseBody_0(this, log_0, contentType_0, content_0, continuation_0);
  if (suspended) 
    return instance;
  else 
    return instance.doResume(null);
};
  Logging.prototype.logResponseException_0 = function(request, cause) {
  if (this.level.info) {
    this.logger.log_61zpoe$('RESPONSE ' + request.url + ' failed with exception: ' + cause);
  }
};
  function Logging$Companion() {
    Logging$Companion_instance = this;
    this.key_pkknsi$_0 = new AttributeKey('ClientLogging');
  }
  Object.defineProperty(Logging$Companion.prototype, 'key', {
  configurable: true, 
  get: function() {
  return this.key_pkknsi$_0;
}});
  Logging$Companion.prototype.prepare_oh3mgy$$default = function(block) {
  var $receiver = new Logging$Config();
  block($receiver);
  var config = $receiver;
  return new Logging(config.logger, config.level, config.filters_8be2vx$);
};
  Logging$Companion.prototype.install_wojrb5$ = function(plugin, scope) {
  plugin.setupRequestLogging_0(scope);
  plugin.setupResponseLogging_0(scope);
};
  Logging$Companion.$metadata$ = {
  kind: Kind_OBJECT, 
  simpleName: 'Companion', 
  interfaces: [HttpClientPlugin]};
  var Logging$Companion_instance = null;
  function Logging$Companion_getInstance() {
    if (Logging$Companion_instance === null) {
      new Logging$Companion();
    }
    return Logging$Companion_instance;
  }
  Logging.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'Logging', 
  interfaces: []};
  function Logging$lambda($receiver) {
    return Unit;
  }
  function Logging_0($receiver, block) {
    if (block === void 0) 
      block = Logging$lambda;
    $receiver.install_dq2y33$(Logging$Companion_getInstance(), block);
  }
  function Coroutine$tryReadText($receiver_0, charset_0, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.exceptionState_0 = 5;
    this.local$$receiver = $receiver_0;
    this.local$charset = charset_0;
  }
  Coroutine$tryReadText.$metadata$ = {
  kind: Kotlin.Kind.CLASS, 
  simpleName: null, 
  interfaces: [CoroutineImpl]};
  Coroutine$tryReadText.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$tryReadText.prototype.constructor = Coroutine$tryReadText;
  Coroutine$tryReadText.prototype.doResume = function() {
  do try {
    switch (this.state_0) {
      case 0:
        this.exceptionState_0 = 2;
        this.state_0 = 1;
        this.result_0 = this.local$$receiver.readRemaining_s8cxhz$(void 0, this);
        if (this.result_0 === COROUTINE_SUSPENDED) 
          return COROUTINE_SUSPENDED;
        continue;
      case 1:
        return readText(this.result_0, this.local$charset);
      case 2:
        this.exceptionState_0 = 5;
        var cause = this.exception_0;
        if (Kotlin.isType(cause, Throwable)) {
          return null;
        } else {
          throw cause;
        }
      case 3:
        this.state_0 = 4;
        continue;
      case 4:
        return;
      case 5:
        throw this.exception_0;
      default:
        this.state_0 = 5;
        throw new Error('State Machine Unreachable execution');
    }
  }  catch (e) {
  if (this.state_0 === 5) {
    this.exceptionState_0 = this.state_0;
    throw e;
  } else {
    this.state_0 = this.exceptionState_0;
    this.exception_0 = e;
  }
} while (true);
};
  function tryReadText($receiver_0, charset_0, continuation_0, suspended) {
    var instance = new Coroutine$tryReadText($receiver_0, charset_0, continuation_0);
    if (suspended) 
      return instance;
    else 
      return instance.doResume(null);
  }
  defineInlineFunction('ktor-ktor-client-logging-js-legacy.io.ktor.client.plugins.logging.tryReadText_ttwl20$', wrapFunction(function() {
  var readText = _.$$importsForInline$$['ktor-ktor-io-js-legacy'].io.ktor.utils.io.core.readText_1lnizf$;
  var Throwable = Error;
  return function($receiver, charset, continuation) {
  try {
    Kotlin.suspendCall($receiver.readRemaining_s8cxhz$(void 0, Kotlin.coroutineReceiver()));
    return readText(Kotlin.coroutineResult(Kotlin.coroutineReceiver()), charset);
  }  catch (cause) {
  if (Kotlin.isType(cause, Throwable)) {
    return null;
  } else 
    throw cause;
}
};
}));
  var compareBy$lambda = wrapFunction(function() {
  var compareValues = Kotlin.kotlin.comparisons.compareValues_s00gnj$;
  return function(closure$selector) {
  return function(a, b) {
  var selector = closure$selector;
  return compareValues(selector(a), selector(b));
};
};
});
  function logHeaders$lambda(it) {
    return it.key;
  }
  function logHeaders($receiver, headers) {
    var sortedHeaders = sortedWith(toList(headers), new Comparator(compareBy$lambda(logHeaders$lambda)));
    var tmp$;
    tmp$ = sortedHeaders.iterator();
    while (tmp$.hasNext()) {
      var element = tmp$.next();
      var key = element.key;
      var values = element.value;
      logHeader($receiver, key, joinToString(values, '; '));
    }
  }
  function logHeader($receiver, key, value) {
    var value_0 = '-> ' + key + ': ' + value;
    $receiver.append_gw00v9$(value_0).append_s8itvh$(10);
  }
  function Coroutine$observe($receiver_0, log_0, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.exceptionState_0 = 1;
    this.local$$receiver = $receiver_0;
    this.local$log = log_0;
  }
  Coroutine$observe.$metadata$ = {
  kind: Kotlin.Kind.CLASS, 
  simpleName: null, 
  interfaces: [CoroutineImpl]};
  Coroutine$observe.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$observe.prototype.constructor = Coroutine$observe;
  Coroutine$observe.prototype.doResume = function() {
  do try {
    switch (this.state_0) {
      case 0:
        if (Kotlin.isType(this.local$$receiver, OutgoingContent$ByteArrayContent)) {
          this.state_0 = 4;
          this.result_0 = writeFully(this.local$log, this.local$$receiver.bytes(), this);
          if (this.result_0 === COROUTINE_SUSPENDED) 
            return COROUTINE_SUSPENDED;
          continue;
        } else {
          if (Kotlin.isType(this.local$$receiver, OutgoingContent$ReadChannelContent)) {
            var responseChannel = ByteChannel();
            var content = this.local$$receiver.readFrom();
            copyToBoth(content, this.local$log, responseChannel);
            return new LoggedContent(this.local$$receiver, responseChannel);
          } else {
            if (Kotlin.isType(this.local$$receiver, OutgoingContent$WriteChannelContent)) {
              var responseChannel_0 = ByteChannel();
              var content_0 = toReadChannel(this.local$$receiver);
              copyToBoth(content_0, this.local$log, responseChannel_0);
              return new LoggedContent(this.local$$receiver, responseChannel_0);
            } else {
              close(this.local$log);
              return this.local$$receiver;
            }
          }
        }
      case 1:
        throw this.exception_0;
      case 2:
        this.state_0 = 3;
        continue;
      case 3:
        this.state_0 = 5;
        continue;
      case 4:
        close(this.local$log);
        return this.local$$receiver;
      case 5:
        return;
      default:
        this.state_0 = 1;
        throw new Error('State Machine Unreachable execution');
    }
  }  catch (e) {
  if (this.state_0 === 1) {
    this.exceptionState_0 = this.state_0;
    throw e;
  } else {
    this.state_0 = this.exceptionState_0;
    this.exception_0 = e;
  }
} while (true);
};
  function observe($receiver_0, log_0, continuation_0, suspended) {
    var instance = new Coroutine$observe($receiver_0, log_0, continuation_0);
    if (suspended) 
      return instance;
    else 
      return instance.doResume(null);
  }
  function Coroutine$toReadChannel$lambda(this$toReadChannel_0, $receiver_0, controller, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.$controller = controller;
    this.exceptionState_0 = 1;
    this.local$this$toReadChannel = this$toReadChannel_0;
    this.local$$receiver = $receiver_0;
  }
  Coroutine$toReadChannel$lambda.$metadata$ = {
  kind: Kotlin.Kind.CLASS, 
  simpleName: null, 
  interfaces: [CoroutineImpl]};
  Coroutine$toReadChannel$lambda.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$toReadChannel$lambda.prototype.constructor = Coroutine$toReadChannel$lambda;
  Coroutine$toReadChannel$lambda.prototype.doResume = function() {
  do try {
    switch (this.state_0) {
      case 0:
        this.state_0 = 2;
        this.result_0 = this.local$this$toReadChannel.writeTo_h3x4ir$(this.local$$receiver.channel, this);
        if (this.result_0 === COROUTINE_SUSPENDED) 
          return COROUTINE_SUSPENDED;
        continue;
      case 1:
        throw this.exception_0;
      case 2:
        return this.result_0;
      default:
        this.state_0 = 1;
        throw new Error('State Machine Unreachable execution');
    }
  }  catch (e) {
  if (this.state_0 === 1) {
    this.exceptionState_0 = this.state_0;
    throw e;
  } else {
    this.state_0 = this.exceptionState_0;
    this.exception_0 = e;
  }
} while (true);
};
  function toReadChannel$lambda(this$toReadChannel_0) {
    return function($receiver_0, continuation_0, suspended) {
  var instance = new Coroutine$toReadChannel$lambda(this$toReadChannel_0, $receiver_0, this, continuation_0);
  if (suspended) 
    return instance;
  else 
    return instance.doResume(null);
};
  }
  function toReadChannel($receiver) {
    return writer(coroutines.GlobalScope, coroutines.Dispatchers.Default, void 0, toReadChannel$lambda($receiver)).channel;
  }
  function get_DEFAULT($receiver) {
    return get_SIMPLE($receiver);
  }
  Object.defineProperty(LogLevel, 'ALL', {
  get: LogLevel$ALL_getInstance});
  Object.defineProperty(LogLevel, 'HEADERS', {
  get: LogLevel$HEADERS_getInstance});
  Object.defineProperty(LogLevel, 'BODY', {
  get: LogLevel$BODY_getInstance});
  Object.defineProperty(LogLevel, 'INFO', {
  get: LogLevel$INFO_getInstance});
  Object.defineProperty(LogLevel, 'NONE', {
  get: LogLevel$NONE_getInstance});
  var package$io = _.io || (_.io = {});
  var package$ktor = package$io.ktor || (package$io.ktor = {});
  var package$client = package$ktor.client || (package$ktor.client = {});
  var package$plugins = package$client.plugins || (package$client.plugins = {});
  var package$logging = package$plugins.logging || (package$plugins.logging = {});
  package$logging.LogLevel = LogLevel;
  package$logging.LoggedContent = LoggedContent;
  Object.defineProperty(Logger, 'Companion', {
  get: Logger$Companion_getInstance});
  package$logging.Logger = Logger;
  package$logging.get_SIMPLE_xjdrvp$ = get_SIMPLE;
  package$logging.get_EMPTY_xjdrvp$ = get_EMPTY;
  Logging.Config = Logging$Config;
  $$importsForInline$$['ktor-ktor-client-logging-js-legacy'] = _;
  Object.defineProperty(Logging, 'Companion', {
  get: Logging$Companion_getInstance});
  package$logging.Logging = Logging;
  package$logging.Logging_wdchs9$ = Logging_0;
  $$importsForInline$$['ktor-ktor-io-js-legacy'] = $module$ktor_ktor_io_js_legacy;
  package$logging.tryReadText_ttwl20$ = tryReadText;
  package$logging.logHeaders_e5nypg$ = logHeaders;
  package$logging.logHeader_1zhciu$ = logHeader;
  package$logging.observe_hgwr3r$ = observe;
  package$logging.get_DEFAULT_xjdrvp$ = get_DEFAULT;
  Logging$Companion.prototype.prepare_oh3mgy$ = HttpClientPlugin.prototype.prepare_oh3mgy$;
  HttpResponseLog = new AttributeKey('HttpResponseLog');
  DisableLogging = new AttributeKey('DisableLogging');
  Kotlin.defineModule('ktor-ktor-client-logging-js-legacy', _);
  return _;
}));
